/*
    Nota: il programma contiene anche 
          delle stampe di controllo non richieste nella traccia
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define E   1.6e-19
#define M   9.1e-31
#define TAU 1.0e-15
#define L   1.0e-6
#define N   100

double rexp(double tau) {
  double x;
  x = (double) rand() / (double) RAND_MAX; 
  return (- tau * log(x));
}

void statistica(int len, double x[], double *media, double *sigma) {
  double s=0, s2;
  int i;
  
  for (i=0; i<len; i++) {
    s += x[i];
  }
  *media = s / (double) len;

  for (i=0; i<len; i++) {
    s2 += pow( (x[i] - *media), 2); 
  }
  *sigma = sqrt( s2 / (double) len) ;
}

int main() {
  double DV=0.;
  double F, a, I, sI, t, x, Dt, Dx, tcorr;
  double TT[N], mediaTT, sigmaTT;
  double stimaI, sigmaI;
  int i, n;
  FILE *fp;
  
  while(DV <= 0) {
    printf("\nDai un valore positivo per la differenza di potenziale (in Volt): ");
    scanf("%lf", &DV);
  }
  printf("DV = %.2f Volt\n", DV);

  srand(1234567); 

  F = E * DV / L;
  a = F / M;
  for (i=0; i<N; i++) {
    t = 0.;
    x = 0.;
    n = 0;
    while(x < L) {
      Dt = rexp(TAU);
      Dx = 0.5 * a * Dt*Dt;
      t += Dt;
      x += Dx;      
      n++;
    }
    tcorr = Dt - sqrt(Dt*Dt - 2/a*(x-L));
    TT[i] = t - tcorr;
    printf(" i=%3d, n=%d, t=%e, TT[i] = %e \n", i, n, t, TT[i]);    
  }

  statistica(N, TT, &mediaTT, &sigmaTT);
  printf("media(TT) = %e,  sigma(TT) = %e\n", mediaTT, sigmaTT);

  stimaI = E / mediaTT;
  sigmaI = sigmaTT / sqrt((double)N) * E / pow(mediaTT, 2);  
  
  printf("stima di I: %e A;   sigma(I) = %e A\n", stimaI, sigmaI);

  fp = fopen("output.txt", "w");
  for (i=0; i<N; i++) {
    fprintf(fp, "%e\n", TT[i]);
  }
  fclose(fp);
  
  return 0;
}
